package smartresource.abb;

import smartresource.core.*;

import java.io.*;
import java.util.Vector;

public class ExpertAgentServerEventHandler extends InterfaceEventHandler
{
	public String handle(String event){

	    String faultBelief=getParameterValue("faultData");

  	    String message="";
	    if(event.startsWith("Get Network")){
		try{
	                File datafile=new File("DB/"+myAgent.getLocalName()+"/received/network.kml");
			int len=(int)datafile.length();
			char mess[]=new char[len];
	               	InputStreamReader iread=new InputStreamReader(new FileInputStream(datafile));
			BufferedReader ff=new BufferedReader(iread);
			int read=ff.read(mess,0,len);
			message=new String(mess,0,read);
			ff.close();

			Vector faults=getBeliefs(new SemanticStatement(faultBelief));
			if(faults!=null){
				for(int e=0;e<faults.size();e++){
					String name=((SemanticStatement)faults.elementAt(e)).subject;
					String id=name.substring(name.length()-1,name.length());
					int ind=message.indexOf("Feeder"+id);
					ind=message.indexOf("khStyleNormal",ind);
					message=message.substring(0,ind)+"khStyleAlert"+message.substring(ind+13);					

					ind=message.indexOf("Feeder"+id, ind);
					ind=message.indexOf("khStyleNormal",ind);
					message=message.substring(0,ind)+"khStyleAlert"+message.substring(ind+13);					
				}
			}
			
		}catch(IOException e){e.printStackTrace();}
	    }	

	    else if(event.startsWith("Get Weather")){
		try{
	                File datafile=new File("DB/"+myAgent.getLocalName()+"/weather.kml");
			int len=(int)datafile.length();
			char mess[]=new char[len];
	               	InputStreamReader iread=new InputStreamReader(new FileInputStream(datafile));
			BufferedReader ff=new BufferedReader(iread);
			int read=ff.read(mess,0,len);
			message=new String(mess,0,read);
			ff.close();

	                datafile=new File("DB/"+myAgent.getLocalName()+"/received/weather.htm");
			len=(int)datafile.length();
			mess=new char[len];
	               	iread=new InputStreamReader(new FileInputStream(datafile));
			ff=new BufferedReader(iread);
			read=ff.read(mess,0,len);
			String weather=new String(mess,0,read);
			ff.close();

			weather=weather.replaceAll("","&auml;").replaceAll("","&ouml;");
			int ind=message.indexOf("<description>");
			message=message.substring(0,ind+13)+"<![CDATA["+weather+"]]>"+message.substring(ind+13);
			
		}catch(IOException e){e.printStackTrace();}
	     }	

	    else if(event.startsWith("Get Faults")){
		try{
	                File datafile=new File("DB/"+myAgent.getLocalName()+"/received/location.kml");
			int len=(int)datafile.length();
			char mess[]=new char[len];
	               	InputStreamReader iread=new InputStreamReader(new FileInputStream(datafile));
			BufferedReader ff=new BufferedReader(iread);
			int read=ff.read(mess,0,len);
			message=new String(mess,0,read);
			ff.close();
		}catch(IOException e){message="<?xml version=\"1.0\" encoding=\"UTF-8\"?><kml><Document></Document></kml>";}
	    }

	    else if(event.startsWith("Get Alerts")){
		try{
	                File datafile=new File("DB/"+myAgent.getLocalName()+"/received/fire.kml");
			int len=(int)datafile.length();
			char mess[]=new char[len];
	               	InputStreamReader iread=new InputStreamReader(new FileInputStream(datafile));
			BufferedReader ff=new BufferedReader(iread);
			int read=ff.read(mess,0,len);
			message=new String(mess,0,read);
			ff.close();
		}catch(IOException e){message="<?xml version=\"1.0\" encoding=\"UTF-8\"?><kml><Document></Document></kml>";}
	    }
		
	    String response="HTTP/1.0 200 OK \r\nContent-Type: text/xml\r\n\r\n"+message;
	    return response;
	}

}
