package smartresource.core;

import java.util.Vector;

class BehaviorRule{

        String uri;
	String classFile;	

	Vector startParams; //of BehaviourStartParameters

	Vector startInContext; //of SemanticStatements, must all be
	Vector doNotStartInContext; //of SemanticStatements, must be none

	Vector needs; //of SemanticStatements, must all be
	Vector achieves; //of SemanticStatements, effects

	SemanticStatement event; //interface event, must be in agent's currentEvent

	Vector addStatements; //of SemanticStatements when started
	Vector removeStatements; //of SemanticStatements when started

	String inactive; //rule is not considered if 'true'

	public BehaviorRule(String uri){
	        this.uri=uri;
	        classFile=null;
        	startInContext=new Vector();
        	doNotStartInContext=new Vector();
        	needs=new Vector();
        	achieves=new Vector();
		event=null;

        	addStatements=new Vector();
        	removeStatements=new Vector();

        	startParams=new Vector();
		inactive="false";
	}

	public boolean equals(Object obj){
		return uri.equals(((BehaviorRule)obj).uri);
	}

}
