package smartresource.shared.gui;

import smartresource.core.*;

import javax.swing.*;
import java.awt.*;

import java.util.Vector;
import java.util.Iterator;

import jade.gui.GuiEvent;


public class SeveralButtonsGUI extends SmartResourceAgentGUI
{
	Vector buttons;
  
	public void construct(){

		Container pane=getContentPane();
		setLayout(new BoxLayout(pane, BoxLayout.Y_AXIS));
		pane.add(Box.createRigidArea(new Dimension(0,10)));

		ActList aActList = new ActList();
	
	        buttons=new Vector();

	        Vector b=getParameterValues("button");

		Iterator it=b.iterator(); 
		while(it.hasNext()){ 
			String text=(String)it.next();
			JButton button=new JButton(text);
			buttons.add(button);
			pane.add(button);
			pane.add(Box.createRigidArea(new Dimension(0,10)));
			button.addActionListener(aActList);
		}

	        pack();
	        setSize((int)getSize().getWidth()+20,(int)getSize().getHeight());
	}

	public void modify(){
		String event=getParameterValue("modify");
		String target=getParameterValue("target");

		int button=new Integer(target).intValue();

		if(event.equals("Enable")){
			((JButton)buttons.elementAt(button-1)).setEnabled(true);
		}
		else if(event.equals("Disable")){
			((JButton)buttons.elementAt(button-1)).setEnabled(false);
		}
	}

	class ActList implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			int button=buttons.indexOf(object)+1;
			GuiEvent ev = new GuiEvent(this, 0);
			ev.addParameter("User ClickedButton "+button);
			myAgent.postGuiEvent(ev);
		}
	}

}
