package smartresource.shared;

import smartresource.core.*;

import java.io.*;
import jade.wrapper.*;

public class CreateAgentBehavior extends ReusableAtomicBehavior{

	public void action() {
	        String name=getParameterValue("name");
		name.equals(""); //to cause exception if null
	        String scripts=getParameterValue("scripts");
		scripts.equals(""); //to cause exception if null
	        String roles=getParameterValue("roles");

		try
	        {  
			Object[] params;
			if(roles==null){
		                params=new Object[1];
		        	params[0]=scripts;
		        }
		        else{
		        	params=new Object[2];
		                params[0]=scripts;
		                params[1]=roles;
		        }

			AgentContainer container=(AgentContainer)myAgent.getContainerController();
			AgentController ag=container.createNewAgent(name, "smartresource.core.SmartResourceAgent", params);
			ag.start();

		} catch (Throwable t){
			t.printStackTrace();
			success=false;
		}
	}
}
